<template>
  <b-container>
    <div class="background_bloc" />
    <h1 class="title">
      Mes commandes
    </h1>
  </b-container>

  <b-container>
    <b-tabs content-class="mt-3">
      <b-tab
        title="ESPACE ACHETEUR"
        active
      >
        <div>
          <b-table
            responsive
            striped
            hover
            :fields="fields"
            :items="items"
          >
            <template #cell(produit)="data"> 
              <router-link
                class="text-primary text-capitalize"
                :to="{ name: 'Detailsproduit', params: { idVendeur: data.item.vendeur_id, id: data.item.produit_id }}"
              >
                {{ data.value }}
              </router-link>
            </template>
            <template #cell(prix)="data"> 
              {{ data.value }}<span>€</span>
            </template>
            <template #cell(action)="data"> 
              <button
                v-if="data.item.statut_id != 2"
                class="btn-cta mx-2 bg-danger text-light"
                @click.prevent="deleteCommande(data.item.numéro, data.item.nb)"
              >
                Supprimer
              </button>
            </template>
          </b-table>
        </div>
      </b-tab>
      <b-tab
        v-if="store.user?.vendeur == false"
        title="ESPACE VENDEUR"
        disabled
      />
      <b-tab
        v-else
        title="ESPACE VENDEUR"
      >
        <div>
          <b-table
            responsive
            striped
            hover
            :fields="fieldsSeller"
            :items="itemsSeller"
          >
            <template #cell(produit)="data"> 
              <router-link
                class="text-primary text-capitalize"
                :to="{ name: 'Detailsproduit', params: { idVendeur: data.item.vendeur_id, id: data.item.produit_id }}"
              >
                {{ data.value }}
              </router-link>
            </template>
            <template #cell(prix)="data"> 
              {{ data.value }}<span>€</span>
            </template>
            <template #cell(acheteur)="data"> 
              <router-link
                class="text-primary text-capitalize"
                :to="{ name: 'Messages', params: { destinataireid: data.item.acheteur_id }}"
              >
                {{ data.value }}
              </router-link>
            </template>
            <template #cell(statut)="data">
              <b-form class="d-flex">
                <select
                  v-model="data.item.selectedStatut"
                  class="form-select"
                >
                  <option
                    v-for="statut in statuts"
                    :key="statut"
                    :value="'/api/statuts/' + statut.id"
                  >
                    {{ statut.nom }}
                  </option>       
                </select>
                <button
                  class="submit btn-cta mx-2"
                  type="submit"
                  @click.prevent="updateCommande(data.item.selectedStatut, data.item.numéro)"
                >
                  Enregistrer
                </button>
              </b-form>
            </template>
          </b-table>
        </div>
      </b-tab>
    </b-tabs>
  </b-container>
  <Modal
    ref="modalMsg"
    :message="message"
    :choix="false"
  />
</template>
<script>
import { defineComponent } from 'vue';
import { useStore } from '@/store/store'
import axios from 'axios';
import Modal from '@/components/Modal.vue';



export default defineComponent({

    components: {
        Modal
    },

    data() {
        return {
            store: useStore(),
            url: process.env.VUE_APP_URL,
            fields: ['numéro', 'produit', 'quantité', 'prix', 'statut', 'action'],
            fieldsSeller: ['numéro', 'produit', 'quantité', 'prix', 'acheteur', 'statut'],
            items: [],
            itemsSeller: [],
            statuts: [],
            message: ''
        }
    },

    mounted() {
        // GET commandes en tant que user
        if(this.store.isConnected){
            axios.get(this.url + "/api/commandes/?utilisateur=" + this.store.user.id)
            .then(res => {      
                let arr = res.data['hydra:member'];
                for (let i = 0; i < arr.length; i++) {
                const commandeUser = arr[i];
                console.log(commandeUser);
                this.items.push({nb: i, numéro: commandeUser.id, produit: commandeUser.produit.titre, vendeur_id: commandeUser.produit.vendeur.id, produit_id: commandeUser.produit.id , quantité: commandeUser.quantite, prix: commandeUser.prix, statut: commandeUser.statut.nom, statut_id: commandeUser.statut.id })
                }
            })
            .catch(err => {
                console.log(err)
            })
        }

        // GET commandes en tant que vendeur
        if(this.store.isConnected && this.store.user.vendeur == true){
            this.store.fetchSeller(this.store.user.id).then( res => {
                axios.get(this.url + "/api/commandes/?order[statut.id]=asc&vendeur=" + this.store.seller.id)
                .then(res => {      
                    let arr = res.data['hydra:member'];
                    let color = '';
                    for (let i = 0; i < arr.length; i++) {
                    const commandeSeller = arr[i];
                    if(commandeSeller.statut.id == 1){
                        color = 'light';
                    } else if (commandeSeller.statut.id == 2){
                        color = 'warning';
                    } else if (commandeSeller.statut.id == 3){
                        color = 'success';
                    } else {
                        color = 'danger';
                    }
                    this.itemsSeller.push({nb: i, numéro: commandeSeller.id, produit: commandeSeller.produit.titre, vendeur_id: commandeSeller.produit.vendeur.id, produit_id: commandeSeller.produit.id , quantité: commandeSeller.quantite, prix: commandeSeller.prix, acheteur: commandeSeller.utilisateur.pseudo, acheteur_id: commandeSeller.utilisateur.id, statut: commandeSeller.statut.nom, statut_id: commandeSeller.statut.id, selectedStatut: '/api/statuts/' + commandeSeller.statut.id, _cellVariants: { statut: color } })
                    }
                    
                    // on récupère les statuts possibles
                    axios.get(this.url + "/api/statuts")          
                    .then(response => {
                        if(response.data['hydra:member'].length > 0){
                            response.data['hydra:member'].forEach(statut => {
                                this.statuts.push(statut);
                                })
                        }
                    })
                    .catch(err => console.log(err))
                })
                .catch(err => {
                    console.log(err)
                })
            })
        }
    },

    methods: {
        updateCommande(vmodel, idcommande){
            console.log(vmodel);
            axios.put(this.url + "/api/commandes/" + idcommande,
                {
                    "statut": vmodel,
                })
                .then(response => {
                    this.message = 'Le statut de la commande a bien été modifié'
                    this.$refs.modalMsg.show = true;
                })    
                .catch(err => {
                    console.log(err);
                })
        },

        deleteCommande(idcommande, arrayKey){
            axios.delete(this.url + "/api/commandes/" + idcommande)
                .then(response => {
                    this.message = 'La commande a bien été supprimée'
                    this.$refs.modalMsg.show = true;
                    this.items.splice(arrayKey, 1);
                })    
                .catch(err => {
                    console.log(err);
                })
        },

    }
})
</script>
